<?php

/**
 * Kelas untuk mendaftarkan semua hooks
 */
class SecureAuth_Authenticator_2FA_Loader {

    /**
     * Array dari actions yang didaftarkan
     *
     * @var array
     */
    protected $actions;

    /**
     * Array dari filters yang didaftarkan
     *
     * @var array
     */
    protected $filters;

    /**
     * Inisialisasi collections
     */
    public function __construct() {
        $this->actions = array();
        $this->filters = array();
    }

    /**
     * Tambahkan action baru ke collection
     *
     * @param string $hook Hook name
     * @param object $component Component yang berisi method
     * @param string $callback Method yang akan dijalankan
     * @param int $priority Priority (default: 10)
     * @param int $accepted_args Jumlah argumen (default: 1)
     */
    public function add_action($hook, $component, $callback, $priority = 10, $accepted_args = 1) {
        $this->actions = $this->add($this->actions, $hook, $component, $callback, $priority, $accepted_args);
    }

    /**
     * Tambahkan filter baru ke collection
     *
     * @param string $hook Hook name
     * @param object $component Component yang berisi method
     * @param string $callback Method yang akan dijalankan
     * @param int $priority Priority (default: 10)
     * @param int $accepted_args Jumlah argumen (default: 1)
     */
    public function add_filter($hook, $component, $callback, $priority = 10, $accepted_args = 1) {
        $this->filters = $this->add($this->filters, $hook, $component, $callback, $priority, $accepted_args);
    }

    /**
     * Utility function untuk menambahkan item ke collection
     *
     * @param array $hooks Collection
     * @param string $hook Hook name
     * @param object $component Component yang berisi method
     * @param string $callback Method yang akan dijalankan
     * @param int $priority Priority
     * @param int $accepted_args Jumlah argumen
     * @return array Collection yang sudah diupdate
     */
    private function add($hooks, $hook, $component, $callback, $priority, $accepted_args) {
        $hooks[] = array(
            'hook'          => $hook,
            'component'     => $component,
            'callback'      => $callback,
            'priority'      => $priority,
            'accepted_args' => $accepted_args
        );
        return $hooks;
    }

    /**
     * Daftarkan semua hooks ke WordPress
     */
    public function run() {
        foreach ($this->filters as $hook) {
            add_filter($hook['hook'], array($hook['component'], $hook['callback']), $hook['priority'], $hook['accepted_args']);
        }
        foreach ($this->actions as $hook) {
            add_action($hook['hook'], array($hook['component'], $hook['callback']), $hook['priority'], $hook['accepted_args']);
        }
    }
}